# bdm::EKFCh Class Reference

`#include <libKF.h>`

Inheritance diagram for bdm::EKFCh:

[legend]

List of all members.

## Detailed Description

Extended Kalman Filter in Square root.

An approximation of the exact Bayesian filter with Gaussian noices and non-linear evolutions of their mean.

## Public Member Functions
| EKFCh ()
| Default constructor.
void | set_parameters (diffbifn *pfxu, diffbifn *phxu, const chmat Q0, const chmat R0)
| Set nonlinear functions for mean values and covariance matrices.
void | bayes (const vec &dt)
| Here dt = [yt;ut] of appropriate dimensions.
void | set_parameters (const mat &A0, const mat &B0, const mat &C0, const mat &D0, const chmat &R0, const chmat &Q0)
| Set parameters with check of relevance.
void | set_est (const vec &mu0, const chmat &P0)
| Set estimate values, used e.g. in initialization.
const epdf & | _epdf () const
| access function
const enorm< chmat > * | _e () const
mat & | __K ()
| access function
vec | _dP ()
| access function
Constructors
virtual BM * | _copy_ ()
Mathematical operations
virtual void | bayesB (const mat &Dt)
| Batch Bayes rule (columns of Dt are observations).
virtual double | logpred (const vec &dt) const
vec | logpred_m (const mat &dt) const
| Matrix version of logpred.
virtual epdf * | epredictor () const
| Constructs a predictive density .
virtual mpdf * | predictor () const
| Constructs a conditional density 1-step ahead predictor.
Access to attributes
const RV & | _drv () const
void | set_drv (const RV &rv)
double | _ll () const
void | set_evalll (bool evl0)
## Protected Attributes
diffbifn * | pfxu
| Internal Model f(x,u).
diffbifn * | phxu
| Observation Model h(x,u).
mat | preA
| pre array (triangular matrix)
mat | postA
| post array (triangular matrix)
RV | rvy
| Indetifier of output rv.
RV | rvu
| Indetifier of exogeneous rv.
int | dimx
| cache of rv.count()
int | dimy
| cache of rvy.count()
int | dimu
| cache of rvu.count()
mat | A
| Matrix A.
mat | B
| Matrix B.
mat | C
| Matrix C.
mat | D
| Matrix D.
chmat | Q
| Matrix Q in square-root form.
chmat | R
| Matrix R in square-root form.
enorm< chmat > | est
| posterior density on $x_t$
enorm< chmat > | fy
| preditive density on $y_t$
mat | _K
| placeholder for Kalman gain
vec & | _yp
| cache of fy.mu
chmat & | _Ry
| cache of fy.R
vec & | _mu
| cache of est.mu
chmat & | _P
| cache of est.R
RV | drv
| Random variable of the data (optional).
double | ll
| Logarithm of marginalized data likelihood.
bool | evalll
| If true, the filter will compute likelihood of the data record and store it in `ll` . Set to false if you want to save computational time.

## Member Function Documentation

virtual BM* bdm::BM::_copy_ | ( |  | ) | `[inline, virtual, inherited]`

Copy function required in vectors, Arrays of BM etc. Have to be DELETED manually! Prototype:

     BM* _copy_(){return new BM(*this);}

Reimplemented in bdm::ARX.

virtual double bdm::BM::logpred | ( | const vec & | dt | ) | const`[inline, virtual, inherited]`

Evaluates predictive log-likelihood of the given data record I.e. marginal likelihood of the data with the posterior integrated out.

Reimplemented in bdm::ARX, bdm::MixEF, and bdm::multiBM.

Referenced by bdm::BM::logpred_m().

The documentation for this class was generated from the following files:

- libKF.h
- libKF.cpp